#property indicator_chart_window

extern string TimeFrame = "Current time frame";
extern int    nPeriod   = 9;
extern int    Limit     = 350;
extern color  WSO_Color = PaleVioletRed;
extern color  WRO_Color = DeepSkyBlue;
extern bool   ShowPrice = true;

//
//
//
//
//

string wso_name;
string wro_name;
int    timeFrame;
string indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   timeFrame = stringToTimeFrame(TimeFrame);
   indicatorFileName = WindowExpertName();
      wso_name="HPT - WSO - " + timeFrameToString(timeFrame);
      wro_name="HPT - WRO - " + timeFrameToString(timeFrame);
   return(0);
}
int deinit()
{
   for(int cnt=0; cnt<6; cnt++) { ObjectDelete(wso_name+cnt); ObjectDelete(wro_name+cnt); }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   if (timeFrame==Period())
   {
      double r1,r2,r3,r4,r5,r6,s1,s2,s3,s4,s5,s6;
      int    rt1,rt2,rt3,rt4,rt5,rt6,st1,st2,st3,st4,st5,st6;
            int limit = MathMin(Limit,Bars-1);
            
            //
            //
            //
            //
            //
            
            for (int nCurBar=limit; nCurBar>=0; nCurBar--)
            {
               if(Low[nCurBar+(nPeriod-1)/2] == Low[Lowest(NULL,0,MODE_LOW,nPeriod,nCurBar)])
               {
                  s6=s5; s5=s4; s4=s3; s3=s2; s2=s1; s1=Low[nCurBar+(nPeriod-1)/2];
                  st6=st5; st5=st4; st4=st3; st3=st2; st2=st1; st1=nCurBar+(nPeriod-1)/2;
               }
               if(High[nCurBar+(nPeriod-1)/2] == High[Highest(NULL,0,MODE_HIGH,nPeriod,nCurBar)])
               {
                  r6=r5; r5=r4; r4=r3; r3=r2; r2=r1; r1=High[nCurBar+(nPeriod-1)/2];
                  rt6=rt5; rt5=rt4; rt4=rt3; rt3=rt2; rt2=rt1; rt1=nCurBar+(nPeriod-1)/2;
               }
            }

            //
            //
            //
            //
            //
   
            FormatLine(wso_name + "0",Time[st1],s1,WSO_Color);
            FormatLine(wso_name + "1",Time[st2],s2,WSO_Color);
            FormatLine(wso_name + "2",Time[st3],s3,WSO_Color);
            FormatLine(wso_name + "3",Time[st4],s4,WSO_Color);
            FormatLine(wso_name + "4",Time[st5],s5,WSO_Color);
            FormatLine(wso_name + "5",Time[st6],s6,WSO_Color);
            
            FormatLine(wro_name + "0",Time[rt1],r1,WRO_Color);
            FormatLine(wro_name + "1",Time[rt2],r2,WRO_Color);
            FormatLine(wro_name + "2",Time[rt3],r3,WRO_Color);
            FormatLine(wro_name + "3",Time[rt4],r4,WRO_Color);
            FormatLine(wro_name + "4",Time[rt5],r5,WRO_Color);
            FormatLine(wro_name + "5",Time[rt6],r6,WRO_Color);
   }
   else iCustom(NULL,timeFrame,indicatorFileName,"",nPeriod,Limit,WSO_Color,WRO_Color,ShowPrice,0,0);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void FormatLine(string objectName,datetime dt,double price, color clr)
{
   ObjectDelete(objectName);
   ObjectCreate(objectName,OBJ_TREND,0,dt,price,dt+Period()*60,price);
      ObjectSet(objectName,OBJPROP_RAY,true);
      ObjectSet(objectName,OBJPROP_WIDTH,1);
      ObjectSet(objectName,OBJPROP_STYLE, STYLE_DOT);
      ObjectSet(objectName,OBJPROP_COLOR,clr);
      ObjectMove(objectName,0,dt,price);
            if (ShowPrice) ObjectSetText(objectName,DoubleToStr(price,Digits));
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}